<?php
/**
 * Created by PhpStorm.
 * User: j.fischer
 * Date: 28.03.19
 * Time: 12:36
 */

namespace Gambio\StyleEdit\Core;

use DirectoryIterator;

/**
 * Class ConfigurationFileReader
 * @package Gambio\StyleEdit\Core\Components\Theme
 */
class JsonFileIO
{
    /**
     * @param $filePath
     *
     * @return array|mixed
     * @throws \Exception
     */
    public function read($filePath)
    {
        if ($this->exists($filePath)) {
            return json_decode(file_get_contents($filePath), false);
        } else {
            throw new \Exception('Invalid file path $filePath');
        }
    }
    
    
    /**
     * @param $filePath
     *
     * @return array|mixed
     */
    public function exists($filePath)
    {
        return file_exists($filePath);
    }
    
    
    /**
     * @param $object
     * @param $filePath
     */
    public function write($object, $filePath)
    {
        return file_put_contents($filePath, json_encode($object, JSON_PRETTY_PRINT));
    }
    
    
    /**
     * @param $path
     *
     * @return array
     */
    public function listDirectory($path)
    {
        
        $themeDirectoryPaths = [];
        
        foreach (new DirectoryIterator($path) as $directory) {
            if (!$directory->isDot() && $directory->isDir() && $directory->isReadable()) {
                $themeDirectoryPaths[] = $path . $directory->getBasename() . DIRECTORY_SEPARATOR;
            }
        }
        
        return $themeDirectoryPaths;
    }
}