<?php
/*--------------------------------------------------------------------------------------------------
    ClearCacheCommand.php 2019-09-26
    Gambio GmbH
    http://www.gambio.de
    Copyright (c) 2019 Gambio GmbH
    Released under the GNU General Public License (Version 2)
    [http://www.gnu.org/licenses/gpl-2.0.html]
    --------------------------------------------------------------------------------------------------
 */

namespace Gambio\StyleEdit\Core\Options\Commands;

use Gambio\StyleEdit\Core\Command\CommandInterface;
use Gambio\StyleEdit\Core\Options\Entities\OptionInterface;
use Gambio\StyleEdit\Core\SingletonPrototype;
use CacheControl;

/**
 * Class ClearCacheCommand
 * @package Gambio\StyleEdit\Core\Options\Commands
 */
class ClearCacheCommand implements CommandInterface
{
    /**
     * @var CacheControl
     */
    protected $cacheControl;
    
    
    /**
     * Execute the command
     */
    public function execute(): void
    {
        $this->cacheControl()->clear_cache();
        $this->cacheControl()->clear_templates_c();
    }
    
    
    /**
     * @return CacheControl
     * @throws \Exception
     */
    protected function cacheControl(): \CacheControl
    {
        if ($this->cacheControl === null) {
            $this->cacheControl = SingletonPrototype::instance()->get(CacheControl::class);
        }
        
        return $this->cacheControl;
    }
    
    
    /**
     * Execute the command
     */
    public function rollback(): void
    {
        // TODO: Implement rollback() method.
    }
    
    
    /**
     * @param \Gambio\StyleEdit\Core\Options\Entities\OptionInterface $option
     */
    public function setOption(OptionInterface $option): void
    {
        // TODO: Implement setOption() method.
    }
}